## kpatch 0.3.2

=== Makefile ===
include Makefile.inc

SUBDIRS     = kpatch-build kpatch kmod man contrib
BUILD_DIRS   = $(SUBDIRS:%=build-%)
INSTALL_DIRS = $(SUBDIRS:%=install-%)
UNINSTALL_DIRS = $(SUBDIRS:%=uninstall-%)
CLEAN_DIRS   = $(SUBDIRS:%=clean-%)

.PHONY: $(SUBDIRS) $(BUILD_DIRS) $(INSTALL_DIRS) $(CLEAN_DIRS)


all: $(BUILD_DIRS)
$(BUILD_DIRS):
	$(MAKE) -C $(@:build-%=%)

install: $(INSTALL_DIRS)
$(INSTALL_DIRS):
	$(MAKE) -C $(@:install-%=%) install

uninstall: $(UNINSTALL_DIRS)
$(UNINSTALL_DIRS):
	$(MAKE) -C $(@:uninstall-%=%) uninstall

clean: $(CLEAN_DIRS)
$(CLEAN_DIRS):
	$(MAKE) -C $(@:clean-%=%) clean

=== contrib/Makefile ===
include ../Makefile.inc

all:

install: all
	$(INSTALL) -d $(SYSTEMDDIR)
	$(INSTALL) -m 0644 kpatch.service $(SYSTEMDDIR)
	sed -i 's~PREFIX~$(PREFIX)~' $(SYSTEMDDIR)/kpatch.service

uninstall:
	$(RM) $(SYSTEMDDIR)/kpatch.service

clean:

=== kmod/Makefile ===
include ../Makefile.inc

all: clean
ifeq ($(BUILDMOD),yes)
	$(MAKE) -C core
endif

install:
ifeq ($(BUILDMOD),yes)
	$(INSTALL) -d $(MODULESDIR)/$(shell uname -r)
	$(INSTALL) -m 644 core/kpatch.ko $(MODULESDIR)/$(shell uname -r)
	$(INSTALL) -m 644 core/Module.symvers $(MODULESDIR)/$(shell uname -r)
endif
	$(INSTALL) -d $(DATADIR)/patch
	$(INSTALL) -m 644 patch/* $(DATADIR)/patch

uninstall:
ifeq ($(BUILDMOD),yes)
	$(RM) -R $(MODULESDIR)
endif
	$(RM) -R $(DATADIR)

clean:
ifeq ($(BUILDMOD),yes)
	$(MAKE) -C core clean
endif

=== kpatch-build/Makefile ===
include ../Makefile.inc

CFLAGS  += -I../kmod/patch -Iinsn -Wall -g -Werror
LDFLAGS += -lelf

TARGETS = create-diff-object
OBJS = create-diff-object.o lookup.o insn/insn.o insn/inat.o
SOURCES = create-diff-object.c lookup.c insn/insn.c insn/inat.c

all: $(TARGETS)

-include $(SOURCES:.c=.d)

%.o : %.c
	$(CC) -MMD -MP $(CFLAGS) -c -o $@ $<

create-diff-object: $(OBJS)
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

install: all
	$(INSTALL) -d $(LIBEXECDIR)
	$(INSTALL) $(TARGETS) kpatch-gcc $(LIBEXECDIR)
	$(INSTALL) -d $(BINDIR)
	$(INSTALL) kpatch-build $(BINDIR)

uninstall:
	$(RM) -R $(LIBEXECDIR)
	$(RM) $(BINDIR)/kpatch-build

clean:
	$(RM) $(TARGETS) $(OBJS) *.d insn/*.d

=== kmod/patch/Makefile ===
KPATCH_NAME ?= patch
KPATCH_BUILD ?= /lib/modules/$(shell uname -r)/build
KPATCH_MAKE = $(MAKE) -C $(KPATCH_BUILD) M=$(PWD)

obj-m += kpatch-$(KPATCH_NAME).o

kpatch-$(KPATCH_NAME)-objs += patch-hook.o kpatch.lds output.o

all: kpatch-$(KPATCH_NAME).ko

kpatch-$(KPATCH_NAME).ko:
	$(KPATCH_MAKE) kpatch-$(KPATCH_NAME).ko

patch-hook.o: patch-hook.c kpatch-patch-hook.c livepatch-patch-hook.c
	$(KPATCH_MAKE) patch-hook.o

clean:
	$(RM) -Rf .*.o.cmd .*.ko.cmd .tmp_versions *.o *.ko *.mod.c \
	Module.symvers

=== test/integration/f22/Makefile ===
all:
	$(error please specify local or remote)

local: slow

remote: remote_slow

slow: clean
	../kpatch-test

quick: clean
	../kpatch-test --quick

cached:
	../kpatch-test --cached

clean:
	rm -f *.ko *.log COMBINED.patch

check_host:
ifndef SSH_HOST
	$(error SSH_HOST is undefined)
endif

SSH_USER ?= root

remote_setup: check_host
	ssh $(SSH_USER)@$(SSH_HOST) exit
	ssh $(SSH_USER)@$(SSH_HOST) "ls kpatch-setup &> /dev/null" || \
	(scp remote-setup $(SSH_USER)@$(SSH_HOST):kpatch-setup && \
	 ssh $(SSH_USER)@$(SSH_HOST) "./kpatch-setup")

remote_sync: remote_setup
	ssh $(SSH_USER)@$(SSH_HOST) "rm -rf kpatch-test"
	rsync -Cavz --include=core $(shell readlink -f ../../..) $(SSH_USER)@$(SSH_HOST):kpatch-test
	ssh $(SSH_USER)@$(SSH_HOST) "cd kpatch-test/kpatch && make"

remote_slow: remote_sync
	ssh $(SSH_USER)@$(SSH_HOST) "cd kpatch-test/kpatch/test/integration/f22 && make slow"

=== debian/changelog ===
kpatch (0.3.2-3ubuntu1) yakkety; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add additional depends for building Ubuntu kernel
    - Ubuntu Specific Patches:
      - output-kernel-build-in-debug.patch
      - ubuntu-kernel-variants.patch
      - use-debian-rules-for-ubuntu-builds.patch
      - use-livepatch-4.5-kernel-features.patch
      - use-ubuntu-utsrelease-for-kpatch-build.patch
    - make dpks updates dir in post-dkms.sh script

 -- Chris J Arges <chris.j.arges@canonical.com>  Tue, 16 Aug 2016 08:41:04 -0500

kpatch (0.3.2-3) unstable; urgency=medium

  * Fixes for Linux 4.6. (Closes: #832091)

 -- Chris J Arges <chris.j.arges@canonical.com>  Wed, 27 Jul 2016 12:22:10 +0200

kpatch (0.3.2-2) unstable; urgency=medium

  * Install kpatch.service file correctly. (Closes: #828193)
  * Update standards version.

 -- Chris J Arges <chris.j.arges@canonical.com>  Mon, 27 Jun 2016 14:01:29 -0500

kpatch (0.3.2-1ubuntu6) yakkety; urgency=medium

  * Allow kpatch-build to build for Ubuntu flavors. (LP: #1586515)

 -- Benjamin M Romer <benjamin.romer@canonical.com>  Tue, 24 May 2016 11:09:54 -0400

kpatch (0.3.2-1ubuntu5) yakkety; urgency=medium

  * Use debian/rules to build the kernel (LP: #1578661)
  * During kernel builds, generate output when not in debug mode to
    prevent builders timing out due to the build appearing hung (LP: #1570012)

 -- Benjamin M Romer <benjamin.romer@canonical.com>  Wed, 04 May 2016 12:49:33 -0400

kpatch (0.3.2-1ubuntu4) xenial; urgency=medium

  [ Chris J Arges ]
  * Use Build-Depends from the Ubuntu linux source package.

  [ Benjamin M Romer ]
  * When running in debug mode, write the linux build output to stdout as well
    as the log file. (LP: #1566924)

 -- Chris J Arges <chris.j.arges@canonical.com>  Thu, 07 Apr 2016 09:20:33 +0100

kpatch (0.3.2-1ubuntu3) xenial; urgency=medium

  * Generate UTS_UBUNTU_RELEASE_ABI for utsrelease.h instead of previous
    attempt. (LP: #1566460)

 -- Chris J Arges <chris.j.arges@canonical.com>  Tue, 05 Apr 2016 18:01:53 +0100

kpatch (0.3.2-1ubuntu2) xenial; urgency=medium

  * Use utsrelease.h as generated in linux-headers-`uname -r` instead of
    regenerating it. (LP: #1560216)

 -- Chris J Arges <chris.j.arges@canonical.com>  Mon, 21 Mar 2016 15:46:31 -0500

kpatch (0.3.2-1ubuntu1) xenial; urgency=medium

  * Ensure we use sympos structures for patched Ubuntu v4.4 kernel.
    (LP: #1548430)

 -- Chris J Arges <chris.j.arges@canonical.com>  Mon, 22 Feb 2016 13:09:36 -0500

kpatch (0.3.2-1) unstable; urgency=medium

  * New upstream release.
    Dropped patches:
    - make-kmod-conditional.patch
    - kmod-core-fix-message.patch
    - kpatch-build-allow-external-ldflags.patch

 -- Chris J Arges <chris.j.arges@canonical.com>  Wed, 17 Feb 2016 16:11:19 -0600

kpatch (0.3.1-2) unstable; urgency=medium

  * Ensure dkms builds for KERNELRELEASE instead of uname -r. (Closes: #812254) 
  * Add kernel-wedge, gawk, bc as dependencies for kpatch-build.
  * Don't require kpatch kmod for kpatch-build.
  * Remove dependency on kpatch-dkms for kpatch-build.

 -- Chris J Arges <chris.j.arges@canonical.com>  Fri, 22 Jan 2016 08:12:06 -0600

kpatch (0.3.1-1) unstable; urgency=medium

  * Initial release (Closes: #810268)

 -- Chris J Arges <chris.j.arges@canonical.com>  Thu, 07 Jan 2016 10:03:07 -0600

=== debian/control ===
Source: kpatch
Section: kernel
Priority: optional
Maintainer: Chris J Arges <chris.j.arges@canonical.com>
Build-Depends: debhelper (>= 9), libelf-dev, dkms
Standards-Version: 3.9.8
Homepage: http://github.com/dynup/kpatch
#Vcs-Git: git://anonscm.debian.org/collab-maint/kpatch.git
#Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/kpatch.git;a=summary

Package: kpatch
Architecture: linux-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, kpatch-dkms,
 linux-headers-amd64 | linux-headers-generic
Description: Runtime tools for Kpatch
 kpatch is a Linux dynamic kernel patching tool which allows you to patch a
 running kernel without rebooting or restarting any processes.  It enables
 sysadmins to apply critical security patches to the kernel immediately, without
 having to wait for long-running tasks to complete, users to log off, or
 for scheduled reboot windows.  It gives more control over up-time without
 sacrificing security or stability.

Package: kpatch-dkms
Architecture: linux-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, dkms
Description: DKMS module for Kpatch
 This package contains the Kpatch module built with DKMS. It installs the source
 and makefiles into the appropriate locations in order to handle various kernel
 versions.

Package: kpatch-build
Architecture: linux-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, dpkg-dev, debhelper (>= 5),
 dh-systemd, cpio, kernel-wedge, kmod, makedumpfile, libelf-dev,
 libnewt-dev, libiberty-dev, rsync, libdw-dev, libpci-dev, pkg-config, flex,
 bison, libunwind8-dev, openssl, libssl-dev, libaudit-dev, bc, python-dev, gawk,
 libudev-dev, autoconf, automake, libtool, uuid-dev, xmlto, docbook-utils,
 ghostscript, transfig, bzip2, sharutils, asciidoc
Suggests: ccache
Description: Build Tools for Kpatch and Livepatch
 kpatch-build is a tool that can build both kpatch and livepatch modules from
 a given patch.

## kpatch 0.5.0

=== Makefile ===
--- 
+++ 
@@ -6,6 +6,7 @@
 UNINSTALL_DIRS = $(SUBDIRS:%=uninstall-%)
 CLEAN_DIRS   = $(SUBDIRS:%=clean-%)
 
+.PHONY: all install uninstall clean check
 .PHONY: $(SUBDIRS) $(BUILD_DIRS) $(INSTALL_DIRS) $(CLEAN_DIRS)
 
 
@@ -24,3 +25,6 @@
 clean: $(CLEAN_DIRS)
 $(CLEAN_DIRS):
 	$(MAKE) -C $(@:clean-%=%) clean
+
+check:
+	shellcheck kpatch/kpatch kpatch-build/kpatch-build kpatch-build/kpatch-gcc

=== kpatch-build/Makefile ===
include ../Makefile.inc

CFLAGS += -MMD -MP -I../kmod/patch -Iinsn -Wall -g -Werror
LDLIBS = -lelf

TARGETS = create-diff-object create-klp-module create-kpatch-module
SOURCES = create-diff-object.c kpatch-elf.c \
		  create-klp-module.c \
		  create-kpatch-module.c \
		  create-kpatch-module.c lookup.c

ifeq ($(ARCH),x86_64)
SOURCES += insn/insn.c insn/inat.c
INSN     = insn/insn.o insn/inat.o
else ifeq ($(ARCH),ppc64le)
SOURCES += gcc-plugins/ppc64le-plugin.c
PLUGIN   = gcc-plugins/ppc64le-plugin.so
TARGETS += $(PLUGIN)
GCC_PLUGINS_DIR := $(shell gcc -print-file-name=plugin)
PLUGIN_CFLAGS    = -shared $(CFLAGS) -I$(GCC_PLUGINS_DIR)/include \
		   -Igcc-plugins -fPIC -fno-rtti -O2 -Wall
endif


all: $(TARGETS)

-include $(SOURCES:.c=.d)

create-diff-object: create-diff-object.o kpatch-elf.o lookup.o $(INSN)
create-klp-module: create-klp-module.o kpatch-elf.o
create-kpatch-module: create-kpatch-module.o kpatch-elf.o

$(PLUGIN): gcc-plugins/ppc64le-plugin.c
	g++ $(PLUGIN_CFLAGS) $< -o $@

install: all
	$(INSTALL) -d $(LIBEXECDIR)
	$(INSTALL) $(TARGETS) kpatch-gcc $(PLUGIN) $(LIBEXECDIR)
	$(INSTALL) -d $(BINDIR)
	$(INSTALL) kpatch-build $(BINDIR)

uninstall:
	$(RM) -R $(LIBEXECDIR)
	$(RM) $(BINDIR)/kpatch-build

clean:
	$(RM) $(TARGETS) *.{o,d} insn/*.{o,d} gcc-plugins/*.{so,d}

=== kmod/core/Makefile ===
# make rules
KPATCH_BUILD ?= /lib/modules/$(shell uname -r)/build
KERNELRELEASE := $(lastword $(subst /, , $(dir $(KPATCH_BUILD))))
THISDIR := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))

ifeq ($(wildcard $(KPATCH_BUILD)),)
$(error $(KPATCH_BUILD) doesn\'t exist.  Try installing the kernel-devel-$(KERNELRELEASE) RPM or linux-headers-$(KERNELRELEASE) DEB.)
endif

KPATCH_MAKE = $(MAKE) -C $(KPATCH_BUILD) M=$(THISDIR)

kpatch.ko: core.c
	$(KPATCH_MAKE) kpatch.ko

all: kpatch.ko

clean:
	$(RM) -Rf .*.o.cmd .*.ko.cmd .tmp_versions *.o *.ko *.mod.c \
	Module.symvers


# kbuild rules
obj-m := kpatch.o
kpatch-y := core.o shadow.o

=== test/integration/Makefile ===
include /etc/os-release

PATCH_DIR?=${ID}-${VERSION_ID}

all:
	$(error please specify local or remote)

local: slow

remote: remote_slow

slow: clean
	./kpatch-test -d $(PATCH_DIR) $(PATCHES)

quick: clean
	./kpatch-test -d $(PATCH_DIR) --quick $(PATCHES)

cached:
	./kpatch-test -d $(PATCH_DIR) --cached $(PATCHES)

clean:
	rm -f *.ko *.log COMBINED.patch

check_host:
ifndef SSH_HOST
	$(error SSH_HOST is undefined)
endif

SSH_USER ?= root

remote_setup: check_host
	ssh $(SSH_USER)@$(SSH_HOST) exit
	ssh $(SSH_USER)@$(SSH_HOST) "ls kpatch-setup &> /dev/null" || \
	(scp remote-setup $(SSH_USER)@$(SSH_HOST):kpatch-setup && \
	 ssh $(SSH_USER)@$(SSH_HOST) "./kpatch-setup")

remote_sync: remote_setup
	ssh $(SSH_USER)@$(SSH_HOST) "rm -rf kpatch-test"
	rsync -Cavz --include=core $(shell readlink -f ../../..) $(SSH_USER)@$(SSH_HOST):kpatch-test
	ssh $(SSH_USER)@$(SSH_HOST) "cd kpatch-test/kpatch && make"

remote_slow: remote_sync
	ssh $(SSH_USER)@$(SSH_HOST) "cd kpatch-test/kpatch/test/integration && make slow"

=== debian/changelog ===
kpatch (0.5.0-0ubuntu1) bionic; urgency=low

   * Upstream bump to 0.5.0 (LP: #1763065).
   * Drop patches that are present in the upstream release:
     - kpatch-build-works-without-kpatch-kmod.patch
     - kmod-core-fix-stacktrace_ops-address-function-protot.patch
     - create-diff-object-fix-WARN-_ONCE-detection-on-newer.patch
     - use-livepatch-4.5-kernel-features.patch
   * output-kernel-build-in-debug.patch was dropped to reduce build output.
   * These remaining patches have been updated to apply to the refreshed
     upstream:
     - kpatch-build-adjust-dirs.patch
     - use-debian-rules-for-ubuntu-builds.patch
     - ubuntu-kernel-variants.patch
   * The shellcheck linter is called during packaging, to verify the quality of
     the scripts used in the package.
   * List the Ubuntu Kernel Team as the package maintainer in the control file
   * kmod/core: fix stacktrace_ops 'address' function prototype for 4.6 (LP: #1665613, #1659581)

 -- Benjamin M Romer <benjamin.romer@canonical.com>  Wed, 11 Apr 2018 21:41:51 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: kpatch
 Section: kernel
 Priority: optional
-Maintainer: Chris J Arges <chris.j.arges@canonical.com>
-Build-Depends: debhelper (>= 9), libelf-dev, dkms
+Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
+XSBC-Original-Maintainer: Chris J Arges <chris.j.arges@canonical.com>
+Build-Depends: debhelper (>= 9), libelf-dev, dkms, shellcheck
 Standards-Version: 3.9.8
 Homepage: http://github.com/dynup/kpatch
 #Vcs-Git: git://anonscm.debian.org/collab-maint/kpatch.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

VERSION ?= $(shell dpkg-parsechangelog |\
	     sed -rne 's/^Version: ([0-9.]+)[-+].*$$/\1/p')
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export BUILDMOD=no

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

override_dh_install:
	mkdir -p debian/tmp/usr/src/kpatch-$(VERSION)
	dh_install -pkpatch-dkms -X.o -X.ko -Xkmod/patch kmod/ usr/src/kpatch-$(VERSION)
	dh_install -pkpatch-dkms Makefile.inc usr/src/kpatch-$(VERSION)
	dh_install -pkpatch-dkms debian/post-dkms.sh usr/src/kpatch-$(VERSION)
	dh_dkms -V $(VERSION)
	dh_install

## kpatch 0.6.0

=== kmod/patch/Makefile ===
KPATCH_BUILD ?= /lib/modules/$(shell uname -r)/build
KPATCH_MAKE = $(MAKE) -C $(KPATCH_BUILD) M=$(PWD)
LDFLAGS += $(KPATCH_LDFLAGS)

# ppc64le kernel modules are expected to compile with the
# -mcmodel=large flag.  This enables 64-bit relocations
# instead of a 32-bit offset from the TOC pointer.
PROCESSOR = $(shell uname -m)
ifeq ($(PROCESSOR), ppc64le)
KBUILD_CFLAGS_MODULE += -mcmodel=large
endif

obj-m += $(KPATCH_NAME).o

$(KPATCH_NAME)-objs += patch-hook.o kpatch.lds output.o

all: $(KPATCH_NAME).ko

$(KPATCH_NAME).ko:
	$(KPATCH_MAKE) $(KPATCH_NAME).ko

patch-hook.o: patch-hook.c kpatch-patch-hook.c livepatch-patch-hook.c
	$(KPATCH_MAKE) patch-hook.o

clean:
	$(RM) -Rf .*.o.cmd .*.ko.cmd .tmp_versions *.o *.ko *.mod.c \
	Module.symvers

=== test/unit/Makefile ===
ARCH=$(shell uname -m)

all: Makefile.include $(ARCH)/Makefile
	$(MAKE) -C $(ARCH)

clean: Makefile.include $(ARCH)/Makefile
	$(MAKE) -C $(ARCH) clean

=== test/unit/x86_64/Makefile ===
include ../Makefile.include

=== debian/changelog ===
kpatch (0.6.0-0.2) unstable; urgency=medium

  * Non-maintainer upload
  * kmod: Fix symbol lookup on Linux 4.19 (Closes: #917861)
  * dkms: Pass target kernel version to the upstream clean target
    (Closes: #917860)
  * kpatch-build: Fix clean target

 -- Ben Hutchings <ben@decadent.org.uk>  Mon, 07 Jan 2019 19:39:23 +0000

kpatch (0.6.0-0.1) unstable; urgency=medium

  [Simon Ruderich]
  * Non-maintainer upload.
  * New upstream release. (Closes: #872413)

  [Nobuhiro Iwamatsu]
  * Add patches/Fix-build-err-by-Werror-maybe-uninitialized.patch.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 16 Jun 2018 07:23:46 +0900

kpatch (0.3.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixes for Linux 4.9: (Closes: #851750)
    - Dropped patch kmod-core-fix-stacktrace_ops-address-function-protot.patch
    - Added patch kmod-core-use-save_stack_trace_tsk-backport.patch: backport
      of upstream commit 586feb40fe116b70d3ac752359706c3e1fafe4ea.
    Thanks to James Beck for the initial revision of this patch.

 -- Chris Boot <bootc@debian.org>  Sat, 01 Apr 2017 20:33:40 +0100

=== debian/control ===
Source: kpatch
Section: kernel
Priority: optional
Maintainer: Chris J Arges <chris.j.arges@canonical.com>
Build-Depends: debhelper (>= 9), libelf-dev, dkms, shellcheck
Standards-Version: 3.9.8
Homepage: http://github.com/dynup/kpatch
Vcs-Git: https://salsa.debian.org/debian/kpatch.git
Vcs-Browser: https://salsa.debian.org/debian/kpatch

Package: kpatch
Architecture: linux-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils
Description: Runtime tools for Kpatch
 kpatch is a Linux dynamic kernel patching tool which allows you to patch a
 running kernel without rebooting or restarting any processes.  It enables
 sysadmins to apply critical security patches to the kernel immediately, without
 having to wait for long-running tasks to complete, users to log off, or
 for scheduled reboot windows.  It gives more control over up-time without
 sacrificing security or stability.

Package: kpatch-dkms
Architecture: linux-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, dkms,
 linux-headers-amd64 | linux-headers-generic
Description: DKMS module for Kpatch
 This package contains the Kpatch module built with DKMS. It installs the source
 and makefiles into the appropriate locations in order to handle various kernel
 versions.

Package: kpatch-build
Architecture: linux-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, dpkg-dev, linux-source, kernel-wedge, gawk, bc
Suggests: ccache
Description: Build Tools for Kpatch and Livepatch
 kpatch-build is a tool that can build both kpatch and livepatch modules from
 a given patch.

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,8 @@
 
 override_dh_auto_install:
 	dh_auto_install -- PREFIX=/usr
+override_dh_auto_test:
+	-dh_auto_test
 
 override_dh_install:
 	mkdir -p debian/tmp/usr/src/kpatch-$(VERSION)

## kpatch 0.8.0

=== kmod/patch/Makefile ===
--- 
+++ 
@@ -11,13 +11,15 @@
 endif
 
 obj-m += $(KPATCH_NAME).o
+ldflags-y += -T $(src)/kpatch.lds
+extra-y := kpatch.lds
 
-$(KPATCH_NAME)-objs += patch-hook.o kpatch.lds output.o
+$(KPATCH_NAME)-objs += patch-hook.o output.o
 
 all: $(KPATCH_NAME).ko
 
 $(KPATCH_NAME).ko:
-	$(KPATCH_MAKE) $(KPATCH_NAME).ko
+	$(KPATCH_MAKE)
 
 patch-hook.o: patch-hook.c kpatch-patch-hook.c livepatch-patch-hook.c
 	$(KPATCH_MAKE) patch-hook.o

=== test/integration/Makefile ===
--- 
+++ 
@@ -17,6 +17,14 @@
 
 cached:
 	./kpatch-test -d $(PATCH_DIR) --cached $(PATCHES)
+
+vagrant: vagrant_quick
+
+vagrant-quick:
+	./test-vagrant
+
+vagrant-slow:
+	./test-vagrant --slow
 
 clean:
 	rm -f *.ko *.log COMBINED.patch

=== debian/changelog ===
kpatch (0.8.0-0ubuntu8) impish; urgency=medium

  * Depend on python3-dev instead of python2-dev, c.f.:
    github.com/dynup/kpatch/commit/4df66fa15f95c86946050ae969658c17caebc0d2

 -- Lukas Märdian <slyon@ubuntu.com>  Tue, 11 May 2021 16:03:30 +0200

kpatch (0.8.0-0ubuntu7) hirsute; urgency=medium

  * Revert the last change, and build explicitly with GCC 9.
    kpatch 0.8 is not ready for GCC 10. There is 0.9.2 ...

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Dec 2020 13:00:04 +0100

kpatch (0.8.0-0ubuntu5) hirsute; urgency=medium

  * Build using gcc-10-plugin-dev.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Dec 2020 12:50:48 +0100

kpatch (0.8.0-0ubuntu4) hirsute; urgency=medium

  * Merge packaging fixes from 0.6.0-0.2 0.6.0-0.1 and 0.3.2-3.1

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Dec 2020 16:03:59 +0100

kpatch (0.8.0-0ubuntu3) hirsute; urgency=medium

  * Drop dh-systemd runtime dependency with debhelper >=10

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Dec 2020 13:08:00 +0100

kpatch (0.8.0-0ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:45:05 +0100

kpatch (0.8.0-0ubuntu1) focal; urgency=low

  [ Benjamin M Romer ]
  * Upstream bump to 0.8.0
  * These remaining patches have been refreshed to apply to the updated
     upstream:
     - kpatch-build-adjust-dirs.patch
     - use-debian-rules-for-ubuntu-builds.patch
     - ubuntu-kernel-variants.patch
  * Packaging changes to produce only kpatch and kpatch-build
     - kpatch-dkms will be deprecated in the upstream soon
     - kmod-fix-symbol-lookup-on-linux-4.19.patch no longer needed
  * Enhance ubuntu-kernel-variants.patch to support additional kernel flavors
  * Added missing devscripts dependency, required by kpatch-build 
  * Added elfutils dependency for ppc64el support
  * Added gcc plugin devpackage dependency for ppc64el support
  * Extra patch for xenial shellcheck version

  [ Matthias Klose ]
  * Depend on python2-dev instead of python-dev.

 -- Benjamin M Romer <benjamin.romer@canonical.com>  Tue, 21 Jan 2020 16:12:05 +0100

kpatch (0.5.0-0ubuntu2) disco; urgency=medium

  * Import v0.6 pataches from unstable for v4.19/v5 compat.
  * Add more shellcheck fixes.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 18 Feb 2019 09:39:39 +0100

=== debian/control ===
Source: kpatch
Section: kernel
Priority: optional
Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
XSBC-Original-Maintainer: Chris J Arges <chris.j.arges@canonical.com>
Build-Depends: debhelper (>= 9), libelf-dev, shellcheck, g++-9, gcc-9-plugin-dev
Standards-Version: 3.9.8
Homepage: http://github.com/dynup/kpatch
Vcs-Git: https://salsa.debian.org/debian/kpatch.git
Vcs-Browser: https://salsa.debian.org/debian/kpatch

Package: kpatch
Architecture: any
Replaces: kpatch-dkms
Depends: ${shlibs:Depends}, ${misc:Depends},
 linux-headers-amd64 | linux-headers-generic
Description: Runtime tools for Kpatch
 kpatch is a Linux dynamic kernel patching tool which allows you to patch a
 running kernel without rebooting or restarting any processes.  It enables
 sysadmins to apply critical security patches to the kernel immediately, without
 having to wait for long-running tasks to complete, users to log off, or
 for scheduled reboot windows.  It gives more control over up-time without
 sacrificing security or stability.

Package: kpatch-build
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, dpkg-dev, debhelper (>= 10),
 cpio, kernel-wedge, kmod, makedumpfile, libelf-dev, devscripts,
 libnewt-dev, libiberty-dev, rsync, libdw-dev, libpci-dev, pkg-config, flex,
 bison, libunwind8-dev, openssl, libssl-dev, libaudit-dev, bc, python3-dev, gawk,
 libudev-dev, autoconf, automake, libtool, uuid-dev, xmlto, docbook-utils,
 ghostscript, transfig, bzip2, sharutils, asciidoc, elfutils
Suggests: ccache
Description: Build Tools for Kpatch and Livepatch
 kpatch-build is a tool that can build both kpatch and livepatch modules from
 a given patch.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

VERSION ?= $(shell dpkg-parsechangelog |\
	     sed -rne 's/^Version: ([0-9.]+)[-+].*$$/\1/p')
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export BUILDMOD=no

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr
override_dh_auto_test:
	-dh_auto_test

## kpatch 0.9.4

=== debian/changelog ===
kpatch (0.9.4-lnd.5) unstable; urgency=medium

  * Non-maintainer upload.
  * kpatch-build: substitute reg0i26_format for i26_format

 -- Xiang Liu <liuxiang@loongson.cn>  Thu, 10 Feb 2022 17:16:33 +0800

kpatch (0.9.4-lnd.4) unstable; urgency=medium

  * Non-maintainer upload
  * fix kpatch not work for new kernel

 -- Hongchen Zhang <zhanghongchen@loongson.cn>  Fri, 2 Jul 2021 12:32:53 +0000

kpatch (0.9.4-lnd.3) unstable; urgency=medium

  * Non-maintainer upload
  * kpatch-build: fix some errors when create diff object
  * add test cases for Loongnix-20

 -- Hongchen Zhang <zhanghongchen@loongson.cn>  Thu, 1 Jul 2021 12:00:53 +0000

kpatch (0.9.4-lnd.1) unstable; urgency=medium

  * Non-maintainer upload
  * kmod: add loongarch64 support
  * kpatch: add loongarch64 support
  * kpatch-build: add loongarch64 support

 -- Hongchen Zhang <zhanghongchen@loongson.cn>  Fri, 18 Jun 2021 01:39:23 +0000

=== debian/control ===
Source: kpatch
Section: kernel
Priority: optional
Maintainer: Chris J Arges <chris.j.arges@canonical.com>
Build-Depends: debhelper (>= 9), libelf-dev,dkms
Standards-Version: 3.9.8
Homepage: http://github.com/dynup/kpatch
Vcs-Git: https://salsa.debian.org/debian/kpatch.git
Vcs-Browser: https://salsa.debian.org/debian/kpatch

Package: kpatch
Architecture: loongarch64
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils
Description: Runtime tools for Kpatch
 kpatch is a Linux dynamic kernel patching tool which allows you to patch a
 running kernel without rebooting or restarting any processes.  It enables
 sysadmins to apply critical security patches to the kernel immediately, without
 having to wait for long-running tasks to complete, users to log off, or
 for scheduled reboot windows.  It gives more control over up-time without
 sacrificing security or stability.

Package: kpatch-dkms
Architecture: loongarch64
Depends: ${shlibs:Depends}, ${misc:Depends},dkms
Description: DKMS module for Kpatch
 This package contains the Kpatch module built with DKMS. It installs the source
 and makefiles into the appropriate locations in order to handle various kernel
 versions.

Package: kpatch-build
Architecture: loongarch64
Depends: ${shlibs:Depends}, ${misc:Depends}, dpkg-dev, kernel-wedge, gawk, bc
Suggests: ccache
Description: Build Tools for Kpatch and Livepatch
 kpatch-build is a tool that can build both kpatch and livepatch modules from
 a given patch.

=== debian/rules ===
--- 
+++ 
@@ -13,5 +13,11 @@
 override_dh_auto_install:
 	dh_auto_install -- PREFIX=/usr
 override_dh_auto_test:
-	-dh_auto_test
 
+override_dh_install:
+	mkdir -p debian/tmp/usr/src/kpatch-$(VERSION)
+	dh_install -pkpatch-dkms -X.o -X.ko -Xkmod/patch kmod/ usr/src/kpatch-$(VERSION)
+	dh_install -pkpatch-dkms Makefile.inc usr/src/kpatch-$(VERSION)
+	dh_install -pkpatch-dkms debian/post-dkms.sh usr/src/kpatch-$(VERSION)
+	dh_dkms -V $(VERSION)
+	dh_install

## kpatch 0.9.9

=== debian/changelog ===
kpatch (0.9.9-6) unstable; urgency=medium

  * d/control: Remove gcc-12-plugin-dev from Build Dependency. Replace
    g++-12 [ppc64el] by g++-14 [ppc64el] (Closes: #1092202).

 -- Emmanuel Arias <eamanu@debian.org>  Sat, 25 Jan 2025 14:18:49 -0300

kpatch (0.9.9-5) unstable; urgency=medium

  * d/patches/remove_cdo_flag_from_script_not_used.patch: Update patch to
    force use --klp-patch in create-diff-object script.
  * d/patches/fix-find-locals_syms.patch: Add patch to look for __pfx_ symbols
    in objects.

 -- Emmanuel Arias <eamanu@debian.org>  Tue, 03 Dec 2024 16:59:42 -0300

kpatch (0.9.9-4) unstable; urgency=medium

  * Remove build-dependecy on g++-11* [ppc64el]
  * wrap-and-sort -ast
  * Enable wrap-and-sort job in Salsa CI
  * Declare compliance with Standards-Version 4.7.0.1
  * Add VCS links to debian/control

 -- Santiago Ruano Rincón <santiago@debian.org>  Fri, 08 Nov 2024 06:59:48 -0300

kpatch (0.9.9-3) unstable; urgency=medium

  * d/gbp.conf: configure debian/latest as default branch for gbp.
  * d/control: Add gcc-14-plugin-dev as Build Depends to obtain
    bversion.h header in ppc64el arch (Closes: #1079032).

 -- Emmanuel Arias <eamanu@debian.org>  Sat, 07 Sep 2024 22:31:43 -0300

kpatch (0.9.9-2) unstable; urgency=medium

  * Remove aliased file /lib/systemd/system/kpatch.service (DEP17). Thanks to
    Helmut Grohne. (Closes: #1077036)

 -- Santiago Ruano Rincón <santiago@debian.org>  Mon, 29 Jul 2024 16:57:54 +0900

kpatch (0.9.9-1) unstable; urgency=low

  [ Santiago Ruano Rincón ]
  * New upstream version 0.9.9
  * Update and refresh d/patches/*
  * Update d/patches/shellcheck.patch (Closes: #1029189)
  * Move kpatch-build dependency from pkg-config to pkgconf
  * Wrap and sort
  * Add initial debian/salsa-ci.yml
  * Add Emmanuel and myself as Uploaders (Closes: #1073855)

  [ Emmanuel Arias ]
  * d/patches/handle_paravirt_absence_linux_v6.8+.patch: Add an upsream patch
    to fix an issue in kpatch-build when it try to check paravirt patching
    code that was removed from linux v6.8+.
  * d/patches/remove_cdo_flag_from_script_not_used.patch: Add patch to remove
    CDO_FLAGS variable from the create-diff-object call.
  * d/patches/handle_paravirt_absence_linux_v6.8+.patch: Add an upsream patch
    to fix an issue in kpatch-build when it try to check paravirt patching
    code that was removed from linux v6.8+.
  * d/patches/remove_cdo_flag_from_script_not_used.patch: Add patch to remove
    CDO_FLAGS variable from the create-diff-object call.

 -- Santiago Ruano Rincón <santiago@debian.org>  Thu, 11 Jul 2024 17:47:56 -0300

kpatch (0.9.7-2) experimental; urgency=medium

  [ Benjamin M Romer ]
  * Further modification to ignore-lubsan-sections to skip altered lubsan
    data.

  [ Dimitri John Ledkov ]
  * Drop libunwind-dev runtime dependency, should not be needed to build
    kernel vmlinux or modules.
  * Make backporting on ppc64el easier by build-depending on both gcc-11
    and gcc-12 plugin development.

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Mon, 28 Nov 2022 21:07:55 +0000

kpatch (0.9.7-1) experimental; urgency=medium

  * Upload to Debian experimental, it's not perfect, but better than
    current situation.

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Fri, 21 Oct 2022 14:42:04 +0100

kpatch (0.9.7-0ubuntu1) devel; urgency=medium

  [ Benjamin M Romer ]
  * Upgrade to latest release
  * The following patches were updated and carried forward
     - shellcheck.patch
     - kpatch-build-adjust-dirs.patch
     - use-debian-rules-for-ubuntu.patch
     - ubuntu-kernel-variants.patch
     - add ignore-lubsan-sections.patch

  [ Dimitri John Ledkov ]
  * Trim trailing whitespace.
  * Bump debhelper from old 10 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Add debian/watch file, using github.
  * Add pahole depends on kpatch-build
  * Drop linux-header Depends from kpatch, packages in the archive must
    not depend on linux-headers, as it cannot know which ones are needed
    for any given kernel.
  * Update homepage URL to https
  * Do not install upstart job
  * Drop include-binaries stanzas, source packages must not include
    pre-built binaries.
  * Bump standards version
  * Drop unused VERSION variable from debian/rules
  * Delete embeded .git repository

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Fri, 21 Oct 2022 14:07:12 +0100

=== debian/control ===
Source: kpatch
Section: kernel
Priority: optional
Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
Uploaders:
 Dimitri John Ledkov <dimitri.ledkov@canonical.com>,
 Emmanuel Arias <eamanu@debian.org>,
 Santiago Ruano Rincón <santiago@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 g++-14 [ppc64el],
 gcc-14-plugin-dev [ppc64el],
 libelf-dev,
 shellcheck,
Standards-Version: 4.7.0.1
Homepage: https://github.com/dynup/kpatch
Vcs-Browser: https://salsa.debian.org/debian/kpatch
Vcs-Git: https://salsa.debian.org/debian/kpatch.git

Package: kpatch
Architecture: amd64 ppc64el s390x
Replaces:
 kpatch-dkms,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Runtime tools for Kpatch
 kpatch is a Linux dynamic kernel patching tool which allows you to patch a
 running kernel without rebooting or restarting any processes.  It enables
 sysadmins to apply critical security patches to the kernel immediately, without
 having to wait for long-running tasks to complete, users to log off, or
 for scheduled reboot windows.  It gives more control over up-time without
 sacrificing security or stability.

Package: kpatch-build
Architecture: amd64 ppc64el s390x
Depends:
 asciidoc,
 autoconf,
 automake,
 bc,
 bison,
 bzip2,
 cpio,
 debhelper (>= 10),
 devscripts,
 docbook-utils,
 dpkg-dev,
 elfutils,
 flex,
 gawk,
 ghostscript,
 kernel-wedge,
 kmod,
 libaudit-dev,
 libdw-dev,
 libelf-dev,
 libiberty-dev,
 libnewt-dev,
 libpci-dev,
 libssl-dev,
 libtool,
 libudev-dev,
 makedumpfile,
 openssl,
 pahole,
 pkgconf,
 python3-dev,
 rsync,
 sharutils,
 transfig,
 uuid-dev,
 xmlto,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ccache,
Description: Build Tools for Kpatch and Livepatch
 kpatch-build is a tool that can build both kpatch and livepatch modules from
 a given patch.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export BUILDMOD=no

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

## kpatch 0.9.10

=== kpatch-build/Makefile ===
include ../Makefile.inc

CFLAGS += -std=gnu11 -MMD -MP -I../kmod/patch -Iinsn -Wall -Wsign-compare \
	  -Wconversion -Wno-sign-conversion -g -Werror
LDLIBS = -lelf

TARGETS = create-diff-object create-klp-module create-kpatch-module
SOURCES = create-diff-object.c kpatch-elf.c \
		  create-klp-module.c \
		  create-kpatch-module.c lookup.c

SOURCES += insn/insn.c insn/inat.c
INSN     = insn/insn.o insn/inat.o
insn/%.o: CFLAGS := $(filter-out -Wconversion, $(CFLAGS))
ifeq ($(ARCH),ppc64le)
SOURCES += gcc-plugins/ppc64le-plugin.c
PLUGIN   = gcc-plugins/ppc64le-plugin.so
TARGETS += $(PLUGIN)
GCC_PLUGINS_DIR := $(shell $(CROSS_COMPILE)gcc -print-file-name=plugin)
PLUGIN_CFLAGS := $(filter-out -std=gnu11 -Wconversion, $(CFLAGS))
PLUGIN_CFLAGS += -shared -I$(GCC_PLUGINS_DIR)/include \
		   -Igcc-plugins -fPIC -fno-rtti -O2 -Wall
endif
ifeq ($(filter $(ARCH),s390x x86_64 ppc64le),)
$(error Unsupported architecture ${ARCH}, check https://github.com/dynup/kpatch/#supported-architectures)
endif


all: $(TARGETS)

-include $(SOURCES:.c=.d)

create-diff-object: create-diff-object.o kpatch-elf.o lookup.o $(INSN)
create-klp-module: create-klp-module.o kpatch-elf.o $(INSN)
create-kpatch-module: create-kpatch-module.o kpatch-elf.o $(INSN)

$(PLUGIN): gcc-plugins/ppc64le-plugin.c
	g++ $(PLUGIN_CFLAGS) $< -o $@

install: all
	$(INSTALL) -d $(LIBEXECDIR)
	$(INSTALL) $(TARGETS) kpatch-cc $(LIBEXECDIR)
	$(INSTALL) -d $(BINDIR)
	$(INSTALL) kpatch-build $(BINDIR)

uninstall:
	$(RM) -R $(LIBEXECDIR)
	$(RM) $(BINDIR)/kpatch-build

clean:
	$(RM) $(TARGETS) *.{o,d} insn/*.{o,d} gcc-plugins/*.{so,d}

=== kmod/patch/Makefile ===
KPATCH_BUILD ?= /lib/modules/$(shell uname -r)/build
KPATCH_MAKE = $(MAKE) -C $(KPATCH_BUILD) M=$(PWD) CFLAGS_MODULE='$(CFLAGS_MODULE)'
LDFLAGS += $(KPATCH_LDFLAGS)

# object files that this Makefile can (re)build on its own
BUILDABLE_OBJS=$(filter-out output.o, $(wildcard *.o))

obj-m += $(KPATCH_NAME).o
ldflags-y += -T $(src)/kpatch.lds
targets += kpatch.lds

$(KPATCH_NAME)-objs += patch-hook.o output.o

all: $(KPATCH_NAME).ko

$(KPATCH_NAME).ko:
	$(KPATCH_MAKE)

$(obj)/$(KPATCH_NAME).o: $(src)/kpatch.lds

patch-hook.o: patch-hook.c kpatch-patch-hook.c livepatch-patch-hook.c

clean:
	$(RM) -Rf .*.o.cmd .*.ko.cmd .tmp_versions $(BUILDABLE_OBJS) *.ko *.mod.c \
	Module.symvers

=== test/unit/Makefile ===
ARCHES ?= ppc64le x86_64

.PHONY: all clean submodule-check

all: $(addsuffix -test,$(ARCHES))
clean: $(addsuffix -clean,$(ARCHES))

submodule-check:
	@cd $(shell git rev-parse --show-toplevel) && \
		git diff-index --quiet HEAD test/unit/objs || \
		echo -e "\nWARNING: unit tests are out of date - run \"git submodule update\"\n"

%-test: Makefile.include submodule-check
	$(MAKE) -C objs/$*

%-clean: Makefile.include
	if [ -d objs/$* ]; then $(MAKE) -C objs/$* clean; fi

=== debian/changelog ===
kpatch (0.9.10-1) unstable; urgency=medium

  * New upstream version.
  * d/rules: Add hardening=+all to DEB_BUILD_MAINT_OPTIONS.
  * d/patches/handle_paravirt_absence_linux_v6.8+.patch: Remove patch.
    It was already applied by upstream.
  * d/patches: Update patches according to new upstream release:
    - remove_cdo_flag_from_script_not_used.patch
    - ubuntu-kernel-variants.patch
    - use-debian-rules-for-ubuntu-builds.patch
  * d/patches/shellcheck.patch: Update patch according to new upstream
    release.
  * d/control: Bump Standards-Version to 4.7.2 (from 4.7.0.1; no further
    changes needed).

 -- Emmanuel Arias <eamanu@debian.org>  Sat, 29 Mar 2025 15:40:54 -0300

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  gcc-14-plugin-dev [ppc64el],
  libelf-dev,
  shellcheck,
-Standards-Version: 4.7.0.1
+Standards-Version: 4.7.2
 Homepage: https://github.com/dynup/kpatch
 Vcs-Browser: https://salsa.debian.org/debian/kpatch
 Vcs-Git: https://salsa.debian.org/debian/kpatch.git

## kpatch 0.9.11

=== Makefile ===
--- 
+++ 
@@ -6,13 +6,25 @@
 UNINSTALL_DIRS = $(SUBDIRS:%=uninstall-%)
 CLEAN_DIRS   = $(SUBDIRS:%=clean-%)
 
-.PHONY: all install uninstall clean check
+UNITTEST_DIR = test/unit
+INTEGRATION_DIR = test/integration
+CLEAN_DIRS  += clean-$(UNITTEST_DIR)
+
+.PHONY: all dependencies install uninstall clean check unit
 .PHONY: $(SUBDIRS) $(BUILD_DIRS) $(INSTALL_DIRS) $(CLEAN_DIRS)
+.PHONY: integration integration-slow integration-quick
+.PHONY: vagrant-integration-slow vagrant-integration-quick vagrant-integration
+.PHONY: vagrant-install
+.PHONY: help
 
 
 all: $(BUILD_DIRS)
 $(BUILD_DIRS):
 	$(MAKE) -C $(@:build-%=%)
+
+dependencies: SHELL:=/bin/bash
+dependencies:
+	source test/integration/lib.sh && kpatch_dependencies
 
 install: $(INSTALL_DIRS)
 $(INSTALL_DIRS):
@@ -26,5 +38,58 @@
 $(CLEAN_DIRS):
 	$(MAKE) -C $(@:clean-%=%) clean
 
+unit: $(UNITTEST_DIR)/Makefile build-kpatch-build
+	$(MAKE) -C $(UNITTEST_DIR)
+
+integration: integration-quick
+
+integration-slow: $(INTEGRATION_DIR)/Makefile build-kpatch-build build-kpatch build-kmod
+	$(MAKE) -C $(INTEGRATION_DIR) slow
+
+integration-quick: $(INTEGRATION_DIR)/Makefile build-kpatch-build build-kpatch build-kmod
+	$(MAKE) -C $(INTEGRATION_DIR) quick
+
+vagrant-install: $(INTEGRATION_DIR)/lib.sh
+ifneq ($(shell id -u), 0)
+	@echo "WARNING: This target is intended for use on freshly-installed machines/vms only." && \
+	echo "Do not proceed unless you read $(INTEGRATION_DIR)/lib.sh and realise what this target does." && \
+	echo "Press ctrl-c to abort, return to proceed." && \
+	read
+endif
+	source $(INTEGRATION_DIR)/lib.sh && kpatch_check_install_vagrant
+
+vagrant-integration: vagrant-integration-quick
+
+vagrant-integration-slow:
+	$(MAKE) -C $(INTEGRATION_DIR) vagrant-slow
+
+vagrant-integration-quick:
+	$(MAKE) -C $(INTEGRATION_DIR) vagrant-quick
+
 check:
-	shellcheck kpatch/kpatch kpatch-build/kpatch-build kpatch-build/kpatch-gcc
+	shellcheck kpatch/kpatch kpatch-build/kpatch-build kpatch-build/kpatch-cc
+	shellcheck test/difftree.sh test/integration/kpatch-test		\
+		   test/integration/lib.sh test/integration/rebase-patches	\
+		   test/integration/test-vagrant				\
+		   test/integration/vm-integration-run
+
+help:
+	@echo "kpatch Makefile"
+	@echo
+	@echo "Targets:"
+	@echo "    make dependencies                 install build dependencies [1]"
+	@echo "    make all                          build entire project"
+	@echo "    make install                      install programs to system [1]"
+	@echo "    make uninstall                    remove programs from system [1]"
+	@echo "    make clean                        clean build files"
+	@echo
+	@echo "Test targets:"
+	@echo "    make check                        run static code analyzers"
+	@echo "    make integration                  build and run integration tests [2]"
+	@echo "    make integration-slow             build and run integration tests [2]"
+	@echo "    make integration-quick            build and run integration tests [2]"
+	@echo "    make unit                         run unit tests"
+	@echo
+	@echo "[1] requires admin privileges"
+	@echo "[2] installs test kpatch kernel modules, run at your own risk"
+	@echo

=== contrib/Makefile ===
--- 
+++ 
@@ -6,8 +6,12 @@
 	$(INSTALL) -d $(SYSTEMDDIR)
 	$(INSTALL) -m 0644 kpatch.service $(SYSTEMDDIR)
 	sed -i 's~PREFIX~$(PREFIX)~' $(SYSTEMDDIR)/kpatch.service
+	$(INSTALL) -d $(UPSTARTDIR)
+	$(INSTALL) -m 0644 kpatch.conf $(UPSTARTDIR)
+	sed -i 's~PREFIX~$(PREFIX)~' $(UPSTARTDIR)/kpatch.conf
 
 uninstall:
 	$(RM) $(SYSTEMDDIR)/kpatch.service
+	$(RM) $(UPSTARTDIR)/kpatch.conf
 
 clean:

=== kmod/Makefile ===
include ../Makefile.inc
KPATCH_BUILD ?= /lib/modules/$(shell uname -r)/build
KERNELRELEASE := $(lastword $(subst /, , $(dir $(KPATCH_BUILD))))

all: clean
ifeq ($(BUILDMOD),yes)
	$(MAKE) -C core
endif

install:
ifeq ($(BUILDMOD),yes)
	$(INSTALL) -d $(MODULESDIR)/$(KERNELRELEASE)
	$(INSTALL) -m 644 core/kpatch.ko $(MODULESDIR)/$(KERNELRELEASE)
	$(INSTALL) -m 644 core/Module.symvers $(MODULESDIR)/$(KERNELRELEASE)
endif
	$(INSTALL) -d $(DATADIR)/patch
	$(INSTALL) -m 644 patch/* $(DATADIR)/patch

uninstall:
ifeq ($(BUILDMOD),yes)
	$(RM) -R $(MODULESDIR)
endif
	$(RM) -R $(DATADIR)

clean:
ifeq ($(BUILDMOD),yes)
	$(MAKE) -C core clean
endif

=== kpatch-build/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 include ../Makefile.inc
 
 CFLAGS += -std=gnu11 -MMD -MP -I../kmod/patch -Iinsn -Wall -Wsign-compare \
-	  -Wconversion -Wno-sign-conversion -g -Werror
+	  -Wconversion -Wno-sign-conversion -g -Werror -D_GNU_SOURCE
 LDLIBS = -lelf
 
 TARGETS = create-diff-object create-klp-module create-kpatch-module
@@ -21,7 +21,7 @@
 PLUGIN_CFLAGS += -shared -I$(GCC_PLUGINS_DIR)/include \
 		   -Igcc-plugins -fPIC -fno-rtti -O2 -Wall
 endif
-ifeq ($(filter $(ARCH),s390x x86_64 ppc64le),)
+ifeq ($(filter $(ARCH),s390x x86_64 ppc64le aarch64),)
 $(error Unsupported architecture ${ARCH}, check https://github.com/dynup/kpatch/#supported-architectures)
 endif

=== kpatch/Makefile ===
include ../Makefile.inc

all:

install: all
	$(INSTALL) -d $(SBINDIR)
	$(INSTALL) kpatch $(SBINDIR)

uninstall:
	$(RM) $(SBINDIR)/kpatch

clean:

=== man/Makefile ===
include ../Makefile.inc

all: kpatch.1.gz kpatch-build.1.gz

kpatch.1.gz: kpatch.1
	gzip -n -c -9 $< > $@

kpatch-build.1.gz: kpatch-build.1
	gzip -n -c -9 $< > $@

install: all
	$(INSTALL) -d $(MANDIR)
	$(INSTALL) -m 644 kpatch.1.gz $(MANDIR)
	$(INSTALL) -m 644 kpatch-build.1.gz $(MANDIR)

uninstall:
	$(RM) $(MANDIR)/kpatch.1*
	$(RM) $(MANDIR)/kpatch-build.1*

clean:
	$(RM) kpatch.1.gz
	$(RM) kpatch-build.1.gz

=== test/unit/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-ARCHES ?= ppc64le x86_64
+ARCHES ?= aarch64 ppc64le x86_64
 
 .PHONY: all clean submodule-check

=== debian/changelog ===
kpatch (0.9.11-1) unstable; urgency=medium

  * New upstream version.
  * debputy lint --auto-fix (routine-update)
  * Update patches according to new upstream release.

 -- Emmanuel Arias <eamanu@debian.org>  Fri, 31 Oct 2025 09:53:16 -0300

=== debian/control ===
--- 
+++ 
@@ -1,29 +1,29 @@
 Source: kpatch
-Section: kernel
-Priority: optional
+Standards-Version: 4.7.2
 Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
 Uploaders:
  Dimitri John Ledkov <dimitri.ledkov@canonical.com>,
  Emmanuel Arias <eamanu@debian.org>,
  Santiago Ruano Rincón <santiago@debian.org>,
+Section: kernel
+Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
  g++-14 [ppc64el],
  gcc-14-plugin-dev [ppc64el],
  libelf-dev,
  shellcheck,
-Standards-Version: 4.7.2
-Homepage: https://github.com/dynup/kpatch
 Vcs-Browser: https://salsa.debian.org/debian/kpatch
 Vcs-Git: https://salsa.debian.org/debian/kpatch.git
+Homepage: https://github.com/dynup/kpatch
 
 Package: kpatch
 Architecture: amd64 ppc64el s390x
-Replaces:
- kpatch-dkms,
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+Replaces:
+ kpatch-dkms,
 Description: Runtime tools for Kpatch
  kpatch is a Linux dynamic kernel patching tool which allows you to patch a
  running kernel without rebooting or restarting any processes.  It enables

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
 export BUILDMOD=no
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
 	dh $@

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/v(\d\S+)\.tar\.gz/kpatch-$1\.tar\.gz/ https://github.com/dynup/kpatch/tags .*\/v(\d\S+)\.tar\.gz
